# Contributing to this project

Thank you for your interest in contributing to this project.

Please be aware of the following guidelines before investing your effort in a pull request:

#### Avoid trivial contributions

In order to discourage activity spam, trivial contributions by **first-time contributors** will be rejected: typos, dependency updates, code formatting, etc.

#### Discuss solutions prior to implementation

Make sure you open a ticket to discuss your technical approach and your plans before you start working on them.  This saves a lot of effort and headache by making sure that your technical solution is valuable to the project.

#### Avoid refactoring or changing unrelated lines

Avoid refactoring existing code unless discussed previously. The exception is code touched by `dart format` (see below).

#### Make sure your code is formatted according to the official style guide

Firedart uses the official Dart guidelines to ensure consistent code style. Please make sure you run `dart format` when making your contribution.

#### Implement tests

If the project includes tests please make sure your contribution doesn't break them. When adding new functionality it is usually good practice to also include explicit tests for it.

#### Limit the change surface in your PR

Difficulty in reviewing PRs grows exponentially with the amount of changes, so please try to keep your contributions small. It is usually preferable to submit multiple smaller PRs than a single large one.

#### Avoid incomplete/draft PRs

Try to make sure your code is ready for review when submitting a PR. If you absolutely must submit a draft PR, make sure it is clearly marked as such.

#### Be respectful of everyone's time

Finally, please understand that participants are rarely being directly compensated for their open source work, so be especially aware of the human on the other side of the screen.
